net.sf.saxon.expr.sort

## Class TextComparer

- java.lang.Object
- - net.sf.saxon.expr.sort.TextComparer

- All Implemented Interfaces:
    Serializable, AtomicComparer

      public class TextComparer
      extends Object
      implements AtomicComparer, Serializable

  A Comparer used for comparing sort keys when data-type="text". The items to be compared are converted to strings, and the strings are then compared using an underlying collator
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TextComparer(AtomicComparer baseComparer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two Items by converting them to strings and comparing the string values.
    `boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
    `AtomicComparer` | `getBaseComparer()` Get the underlying comparer (which doesn't do conversion to string)
    `StringCollator` | `getCollator()` Get the collation used by this AtomicComparer if any
    `ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
    `AtomicComparer` | `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TextComparer

          public TextComparer(AtomicComparer baseComparer)

  - ### Method Detail

    - #### getBaseComparer

          public AtomicComparer getBaseComparer()

      Get the underlying comparer (which doesn't do conversion to string)

    - #### getCollator

          public StringCollator getCollator()

      Description copied from interface: `AtomicComparer`
      Get the collation used by this AtomicComparer if any
      Specified by:
        `getCollator` in interface `AtomicComparer`
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          public AtomicComparer provideContext(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Specified by:
        `provideContext` in interface `AtomicComparer`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified
      Throws:
        `NoDynamicContextException` - if the context is an "early evaluation" (compile-time) context

    - #### compareAtomicValues

          public int compareAtomicValues(AtomicValue a,
                                AtomicValue b)
                                  throws ClassCastException,
                                         NoDynamicContextException

      Compare two Items by converting them to strings and comparing the string values.
      Specified by:
        `compareAtomicValues` in interface `AtomicComparer`
      Parameters:
        `a` - the first Item to be compared.
        `b` - the second Item to be compared.
      Returns:
        <0 if a0 if a>b
      Throws:
        `ClassCastException` - if the objects are not Items, or are items that cannot be convered to strings (e.g. QNames)
        `NoDynamicContextException` - if this comparer required access to dynamic context information, notably the implicit timezone, and this information is not available. In general this happens if a context-dependent comparison is attempted at compile-time, and it signals the compiler to generate code that tries again at run-time.

    - #### comparesEqual

          public boolean comparesEqual(AtomicValue a,
                              AtomicValue b)
                                throws NoDynamicContextException

      Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.
      Specified by:
        `comparesEqual` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared.
        `b` - the second object to be compared.
      Returns:
        true if the values are equal, false if not
      Throws:
        `ClassCastException` - if the objects are not comparable
        `NoDynamicContextException`

    - #### getComparisonKey

          public ComparisonKey getComparisonKey(AtomicValue a)
                                         throws NoDynamicContextException

      Get a comparison key for an object. This must satisfy the rule that if two objects are equal according to the XPath eq operator, then their comparison keys are equal according to the Java equals() method, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.
      Specified by:
        `getComparisonKey` in interface `AtomicComparer`
      Throws:
        `NoDynamicContextException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.